# AmazonCreateCloudTrailTrailsParameters Object

## Description

Parameters for the Amazon Create CloudTrail Trails action.

## Properties

### bucketName

Name of the S3 bucket used to store the trail events.

Type: `string`

Required: Yes

### cloudWatchLogsProperties

Enables CloudWatch logs on the new trails.

Type: [CloudTrailCloudWatchLogsProperties](/data-types/cloudtrailcloudwatchlogsproperties-object.md) object

Required: No

### creationRule

Rule determining if the trails will be created.

Type: string

Valid Values:

* `create-always`
* `create-if-needed`
* `created-if-name-does-not-exist`

Required: Yes

### credentialIds

Registered credentials to use with the action. One and only one credential must be specified.

Type: Array of `string`

Required: Yes

### globalServicesEventsLocation

Indicates which trails will be enabled as targets for global services events.

Type: string

Valid Values:

* `none`
* `all-regions`
* `executing-region-only`

Required: Yes

### isEnableLogFileValidation

Indicates whether log file validation is enabled on the trail.

Type: `boolean`

Required: No

Default: false

### kmsKeyId

ID of the KMS key to use to encrypt the objects stored in the S3 bucket.

Type: `string`

Required: No

### multiRegionLocation

Indicates which trails will be enabled as "multi-region".

Type: string

Valid Values:

* `none`
* `all-regions`
* `executing-region-only`

Required: Yes

### prefix

Prefix applied to all event objects stored into the S3 bucket.

Type: `string`

Required: No

### regionNames

Regions to use with the action. One and only one region must be specified.

Type: Array of `string`

Required: Yes

### regionsToApply

Regions to create the regions in.

Type: string

Valid Values:

* `all-regions`
* `executing-region-only`

Required: Yes

### snsTopicName

Name of the SNS topic to send notifications to.

Type: `string`

Required: No

### tags

Resource tags to apply to the new trails.

Type: Array of [Tag](/data-types/tag-object.md) objects

Required: No

### trailName

Name of the trail to be created.

Type: `string`

Required: Yes

## Sample JSON

```javascript
{
    "credentialIds": [
        "cred-00000001"
    ],
    "regionNames": [
        "us-east-1"
    ],
    
    "stackName": "stack-$(DATE)",
    "templateFormat": "s3-bucket",
    "templateBucketName": "bucket1",
    "templateObjectKey": "template.json",
    
    "parameters": [
        "key": "param1",
        "value": "value1"
    ],
    
    "capabilities": [
        "iam"
    ],
    
    "tags": [
        {
            "key": "Environment",
            "value": "Development"
        }
    ],
    
    "failureBehaviour": "delete-stack",
    
    "deleteTimeInSeconds": 3600
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.skeddly.com/data-types/actionparameters-object/amazoncreatecloudtrailtrailsparameters-object.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
